Subject: [dhcwg] Character Encoding of DNS domain option (option 15) RFC 2132

From: VithalPrasad Gaitonde <[email-masked]>
Date: Sun, 23 Oct 2011 23:49:13 +0530

Hi,

What is the character format to be used for encoding of DNS domain in option
15.
Should this be UTF8 or UTF16 or Unicode.

More generically, what is the character format to be used for any option
value which is of string data type.
RFC 2132 seems to be silent on this aspect. Is this documented in any other
standards document.

Thanks,
Prasad

---

From: Ted Lemon <[email-masked]>
Date: Sun, 23 Oct 2011 19:27:44 +0000

On Oct 23, 2011, at 2:19 PM, VithalPrasad Gaitonde wrote:
What is the character format to be used for encoding of DNS domain in option 15.
Should this be UTF8 or UTF16 or Unicode.

I would expect it to be whatever is specified in RFC1034, which appears to assume plain old ASCII.   You could try whatever the IDN documents specify; the standard is silent on the question, so what works in any given circumstance will depend on the implementation.

More generically, what is the character format to be used for any option value which is of string data type.
RFC 2132 seems to be silent on this aspect. Is this documented in any other standards document.

This is because of the age of the drafts: the question of I18N was relatively new then.   Again, in general, expect this to be implementation-dependent.   UTF-8 will probably work in cases where it makes sense, but you can't safely assume that it will.   If you are specifying a new option, I would suggest specifying UTF-8.

---

From: Marc Blanchet <[email-masked]>
Date: Sun, 23 Oct 2011 15:30:13 -0400

don't agree about UTF-8. idns are encoded on the wire as normal domain names, i.e. restricted ascii. 

Marc.

Le 2011-10-23 à 15:27, Ted Lemon a écrit :

> _______________________________________________
> dhcwg mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dhcwg

---

From: Ted Lemon <[email-masked]>
Date: Sun, 23 Oct 2011 19:36:20 +0000

On Oct 23, 2011, at 3:30 PM, Marc Blanchet wrote:
don't agree about UTF-8. idns are encoded on the wire as normal domain names, i.e. restricted ascii.

Clearly you didn't read what I said in the first paragraph.   :)   As you say, for DNS you can't use UTF-8.

---

From: Marc Blanchet <[email-masked]>
Date: Sun, 23 Oct 2011 15:49:36 -0400

I read it, but maybe I misunderstood. Anyway, back to the original question, my point is that the character encoding of DNS domain option in dhcp must be restricted ascii (and that includes the support of idn).

Marc.

---

From: VithalPrasad Gaitonde <[email-masked]>
Date: Thu, 27 Oct 2011 22:31:34 +0530

I am still a bit confused here...
To ensure interoperability with standards compliant DHCP clients, what is
the character encoding that the server should use...and the converse.

Or are we saying that interoperability is broken here as the standard is
silent on the issue leaving implementations to take a possibly different
approach and thereby be non-interoperable.

Thanks,
Prasad

On Mon, Oct 24, 2011 at 1:19 AM, Marc Blanchet <[email-masked]>wrote:

> I read it, but maybe I misunderstood. Anyway, back to the original
> question, my point is that the character encoding of DNS domain option in
> dhcp must be restricted ascii (and that includes the support of idn).
>
> Marc.
>

---

From: Ted Lemon <[email-masked]>
Date: Thu, 27 Oct 2011 17:15:00 +0000

On Oct 27, 2011, at 1:01 PM, VithalPrasad Gaitonde wrote:
Or are we saying that interoperability is broken here as the standard is silent on the issue leaving implementations to take a possibly different approach and thereby be non-interoperable.

RFC1533 generally says to use NVT ASCII.   If you want to go outside of that, you are indeed in uncharted waters, and interoperability is not guaranteed.

---

From: Marc Blanchet <[email-masked]>
Date: Thu, 27 Oct 2011 14:35:16 -0400

to me, you are just looking into big troubles if you use a character encoding for DNS names in DHCP that is different than the standardized character encoding for DNS names everywhere else. so I would stick to restricted ascii. no utf8. nothing else.

Marc.

Le 2011-10-27 à 13:01, VithalPrasad Gaitonde a écrit :

> To ensure interoperability with standards compliant DHCP clients, what is the character encoding that the server should use...and the converse.
>  
> On Mon, Oct 24, 2011 at 1:19 AM, Marc Blanchet <[email-masked]> wrote:

---

From: ravi kumar <[email-masked]>
Date: Fri, 28 Oct 2011 08:47:25 +0530

Do ISC DHCP implementations conform to RFC1533 in rergard to character
encondings?

regards
Ravi
On Fri, Oct 28, 2011 at 12:05 AM, Marc Blanchet
<[email-masked]>wrote:

> to me, you are just looking into big troubles if you use a character
> encoding for DNS names in DHCP that is different than the standardized
> character encoding for DNS names everywhere else. so I would stick to
> restricted ascii. no utf8. nothing else.
>
> Marc.
>

---

From: Ted Lemon <[email-masked]>
Date: Fri, 28 Oct 2011 05:08:08 +0000

On Oct 27, 2011, at 11:17 PM, "ravi kumar" <[email-masked]> wrote:
> Do ISC DHCP implementations conform to RFC1533 in rergard to character encondings?

What would that mean?

---

From: VithalPrasad Gaitonde <[email-masked]>
Date: Fri, 28 Oct 2011 13:52:44 +0530

Thanks for the responses, Marc, Ted.

Does that imply then that in case internationalized domain names, punycode
should be used ?

Regards,
Prasad

---

From: Marc Blanchet <[email-masked]>
Date: Fri, 28 Oct 2011 08:36:51 -0400

Le 2011-10-28 à 04:22, VithalPrasad Gaitonde a écrit :

> Does that imply then that in case internationalized domain names, punycode should be used ?

punycode encoding is used for internationalized domain names. the punycode encoded idn conforms to the restricted ascii. So from dhcp, dns, ... point of view, an idn is just a regular domain name. therefore, the dhcp option should have restricted ascii, whatever the domain name is a normal one or an idn.

Marc.

>  
> Regards,
> Prasad
> 
> On Fri, Oct 28, 2011 at 12:05 AM, Marc Blanchet <[email-masked]> wrote:

---

From: VithalPrasad Gaitonde <[email-masked]>
Date: Mon, 31 Oct 2011 18:43:39 +0530

Thanks Marc. Would the same apply to the Domain Name field in option 81
defined in RFC 4702 as well.

Prasad

On Fri, Oct 28, 2011 at 6:06 PM, Marc Blanchet <[email-masked]>wrote:

> punycode encoding is used for internationalized domain names. the punycode
> encoded idn conforms to the restricted ascii. So from dhcp, dns, ... point
> of view, an idn is just a regular domain name. therefore, the dhcp option
> should have restricted ascii, whatever the domain name is a normal one or
> an idn.
>
> Marc.
>
>
> >
> > Regards,
> > Prasad
> >
> > > To ensure interoperability with standards compliant DHCP clients, what
> is the character encoding that the server should use...and the converse.
> > >
> > > Or are we saying that interoperability is broken here as the standard
> is silent on the issue leaving implementations to take a possibly different